<?php

namespace DAO;



class GoodsScoreStatisticsModel extends \DAO\AbstractModel {



    /**
     * 表名
     *
     * @var string
     */
    protected $_tableName = 'han_goods_score_statistics';

    /**
     * 主键
     *
     * @var string
     */
    protected $_primaryKey = 'id';
    public function init(){

    }
    public function getOne($field,$where){
        $this->setDb();
        return $this->db->select($field)->from($this->_tableName)->where($where)->fetchOne();
    }
    public function insertAllOrUpdate($datas){
        $this->setDb(\Our\DbNameConst::masterDBConnectName);
        $error = 0;
        $baseSql = "insert into {$this->_tableName}(goods_commonid,evaluation_score,evaluation_number,evaluation_img_number) values";
        $insertAllSql = $baseSql;
        for ($i = 0; $i < count($datas); $i++) {
            $addSql = \Our\Common::format("({0},{1},{2},{3}),", $datas[$i]['goods_commonid'], $datas[$i]['evaluation_score'], $datas[$i]['evaluation_number'],$datas[$i]['evaluation_img_number']);
            $insertAllSql .= $addSql;
            if ($i % 1000 == 0 && $i != 0) {
                $insertAllSql = rtrim($insertAllSql, ',');
                $insertAllSql .= 'ON DUPLICATE KEY UPDATE evaluation_number = VALUES(evaluation_number),evaluation_score=VALUES(evaluation_score),evaluation_img_number=VALUES(evaluation_img_number)';
                $one = $this->db->insert()->query($insertAllSql);
                if ($one === false) {
                    $error++;
                }
                $insertAllSql = $baseSql;
            }
        }
        if ($insertAllSql != $baseSql) {
            $insertAllSql = rtrim($insertAllSql, ',');
            $insertAllSql .= 'ON DUPLICATE KEY UPDATE evaluation_number = VALUES(evaluation_number),evaluation_score=VALUES(evaluation_score),evaluation_img_number=VALUES(evaluation_img_number)';
            $one = $this->db->insert($this->_tableName)->query($insertAllSql);
            if ($one === false) {
                $error++;
            }
        }
        if ($error > 0) {
            return false;
        }
        return true;
    }
    /**
     * 获取商品评分
     * @param $StoreId
     * @return mixed
     */
    public function getGrade($goodsCommonId,$commonInfo = null){
        $statisticsDb6Redis = \Redis\Db6\StatisticsRedisModel::getInstance();
        $grade = $statisticsDb6Redis->tableHGet('goodsCommon',$goodsCommonId);
        if($grade === false){
            if(!$commonInfo){
                $goodsScoreDAO = \DAO\GoodsScoreStatisticsModel::getInstance();
                $commonInfo = \Our\RedisHelper::cachedFunction(\Redis\Db4\GoodsScoreStatisticsRedisModel::getInstance(),array(&$goodsScoreDAO, 'getOne'),array('*',array('goods_commonid'=>$goodsCommonId)),\Our\ApiConst::oneDaySecond,array($goodsCommonId));
                if($commonInfo === false){
                    $commonInfo['evaluation_number'] = 0;
                    $commonInfo['evaluation_img_number'] = 0;
                    $commonInfo['evaluation_score'] = 0;
                }
            }
            $grade = array();
            $grade['evaluation_score'] = $commonInfo['evaluation_score'];
            $grade['evaluation_number'] = $commonInfo['evaluation_number'];
            $grade['evaluation_img_number'] = $commonInfo['evaluation_img_number'];
            $statisticsDb6Redis->tableHSet('goodsCommon',$goodsCommonId,serialize($grade));
            return $grade;
        }
        return unserialize($grade);
    }
    /**
     * 类实例
     *
     * @var \DAO\UserModel
     */
    private static $_instance = null;

    /**
     * 获取类实例
     *
     * @return \DAO\UserModel
     */
    public static function getInstance() {
        if (!(self::$_instance instanceof self)) {
            self::$_instance = new self();
        }

        return self::$_instance;
    }

}
